<%
    Const VLIMAGE_UNKNOWN =             0
    Const VLIMAGE_BMP =                 1
    Const VLIMAGE_GIF =                 2
    Const VLIMAGE_JPG =                 3
    Const VLIMAGE_PNG =                 4
    Const VLIMAGE_ICO =                 5
    Const VLIMAGE_TIF =                 6
    Const VLIMAGE_TGA =                 7
    Const VLIMAGE_PCX =                 8
    Const VLIMAGE_WBMP =                9
    Const VLIMAGE_WMF =                 10
    Const VLIMAGE_JP2 =                 11
    Const VLIMAGE_JPC =                 12
    Const VLIMAGE_PGX =                 13

    Set fso = Server.CreateObject("Scripting.FileSystemObject")
    
    Dim strCaption
    strCaption = CStr(Request.QueryString("LabelCaption"))
    If strCaption <> "" Then
        If Not fso.FolderExists(Server.MapPath(strCaption)) Then
            fso.CreateFolder Server.MapPath(strCaption)
        End If
        
        ' Deal with the different elements
        If Request.QueryString("ElementType").Count Then
            ' An element
            If CLng(Request.QueryString("ElementType")) = 5 Then
                ' An image - save it
                Set strm = Server.CreateObject("ADODB.Stream")
                strm.Open
                strm.Type = 1
                strm.Write Request.BinaryRead(Request.TotalBytes)
                
                saveFileName = "Image-" & Request.QueryString("Name")
                bSaved = False
                Select Case CLng(Request.QueryString("ImageType"))
                    Case VLIMAGE_BMP
                        saveFileName = saveFileName & ".bmp"
                        bSaved = True
                    Case VLIMAGE_GIF
                        saveFileName = saveFileName & ".gif"
                        bSaved = True
                    Case VLIMAGE_JPG
                        saveFileName = saveFileName & ".jpg"
                        bSaved = True
                    Case VLIMAGE_PNG
                        saveFileName = saveFileName & ".png"
                        bSaved = True
                    Case VLIMAGE_TIF
                        saveFileName = saveFileName & ".tiff"
                        bSaved = True
                    Case VLIMAGE_TGA
                        saveFileName = saveFileName & ".tga"
                        bSaved = True
                    Case Else
                        Response.Write "Error: Do not know how to save image type:" & _
                                       Request.QueryString("ImageType") & " Element name:" & _
                                       Request.QueryString("Name") & vbCrLf
                End Select
                
                If bSaved Then
                    On Error Resume Next
                    fso.DeleteFile Server.MapPath(strCaption) & "\" & saveFileName, True
                    On Error Goto 0
                    strm.SaveToFile Server.MapPath(strCaption) & "\" & saveFileName, 2
                    Response.Write "OK " & saveFileName & vbCrLf
                    Response.Write "Image saved as " & saveFileName
                End If
                Set strm = Nothing
            ElseIf CLng(Request("ElementType")) = 2 Then
                ' Ignore the upload
                Response.Write "OK" & vbCrLf
            Else
                Response.Write "Error: Unknown element type:" & Request.QueryString("ElementType") & vbCrLf
            End If
        Else
            ' The label file itself
            Set strm = Server.CreateObject("ADODB.Stream")
            strm.Open
            strm.Type = 1
            strm.Write Request.BinaryRead(Request.TotalBytes)
            saveFileName = Server.MapPath(strCaption) & "\" & "label.activelabel"
            On Error Resume Next
            fso.DeleteFile saveFileName, True
            On Error Goto 0
            strm.SaveToFile saveFileName, 2
            Response.Write "OK" & vbCrLf
            Response.Write "Label saved as: " & strCaption & "/label.activelabel" & vbCrLf
            Set strm = Nothing
        End If
    Else
        Response.Write "Error: Empty label caption - please set a caption in the label properties" & vbCrLf
    End If
%>