<% @Language=VBScript %>
<%  
    ' Open the database
    Set db = Server.CreateObject("ADODB.Connection")
    db.Open "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & Server.MapPath("clothing.mdb") & ";"
    
    ' We extract the data according to the parameters sent to the page
    qry = "SELECT * FROM Clothing, Types WHERE Clothing.Type=Types.TypeID"
    
    ' In this case we use these two variables to pass parameters to the script that loads the label.
    Dim SelType, SelSize
    SelType = ""
    SelSize = ""
    
    If Request("Type") <> "" Then 
        qry = qry & " AND [Type]=" & Request("Type")
        SelType = Request("Type")
    End If
    If Request("Size") <> "" Then 
        qry = qry & " AND [Size]='" & Request("Size") & "'"
        SelSize = Request("Size")
    End If
    
    Set rstItems = db.Execute(qry)
    
%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<title>Clothing - Using DATA attribute - Step 4.1</title>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>

<body>
<table border="0" bgcolor="#476747" cellspacing="1">
  <tr>
    <td bgcolor="#EAEEE6" valign="top"><a href="default.htm">Step 1</a></td>
    <td bgcolor="#EAEEE6" valign="top"><a href="step2.htm">Step 2</a></td>
    <td bgcolor="#EAEEE6" valign="top"><a href="step31.htm">Step 3.1</a><br>
      <a href="step32.htm">Step 3.2</a><br>
      <a href="step33.htm">Step 3.3</a></td>
    <td bgcolor="#EAEEE6" valign="top">
      <p align="left"><a href="step41.asp">Step 4.1</a><br>
      <a href="step42.htm">Step 4.2</a></td>
  </tr>
</table>

<p><b><font color="#FF0000">Step 4</font><br>
Clothing - ASP with DATA initialization.&nbsp;</b></p>
<OBJECT ID="VisiLabel"  
        CLASSID="CLSID:09A02CEE-410B-47BA-A837-E62C9C8D70BF" 
        Width="100%" HEIGHT="300" DATA="step41data.asp?Type=<%= SelType%>&Size=<%= SelSize %>">
</OBJECT>
<table border="1" width="100%">
  <tr>
    <th width="100%" nowrap colspan="2" bgcolor="#C2D6DC">Client side</th>
  </tr>
  <tr>
    <th width="50%" nowrap>Data record</th>
    <th width="50%" nowrap>Printing</th>
  </tr>
  <tr>
    <td width="50%" valign="top">
      <input type="button" value="Reset" onClick="VisiLabel.Variables.Reset();VisiLabel.Variables.UpdateLabel();">
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="button" value="First" onClick="VisiLabel.Variables.MoveFirst();VisiLabel.Variables.UpdateLabel();">
      <input type="button" value="Previous" onClick="VisiLabel.Variables.MovePrev();VisiLabel.Variables.UpdateLabel();">
      <input type="button" value="Next" onClick="VisiLabel.Variables.MoveNext();VisiLabel.Variables.UpdateLabel();">
      <input type="button" value="Last" onClick="VisiLabel.Variables.MoveLast();VisiLabel.Variables.UpdateLabel();"></td>
    <td width="50%" valign="top">
      <input type="button" value="Print" onClick="VisiLabel.Print(0,100);"></td>
  </tr>
  <tr>
    <th width="100%" valign="top" colspan="2" nowrap bgcolor="#FFCF9C">
      Server side</th>
  </tr>
  <tr>
    <td width="100%" valign="top" colspan="2">
      <form method="POST" action="step41.asp">
        <p>Load label data for: 
        <%
            ' We use simple database without tables for everything so we collect some data for
            ' the drop downs with a couple of simple queries
            
            Set rst = db.Execute("SELECT TypeID, TypeName FROM Types")
        %>
        <select size="1" name="Type">
            <OPTION VALUE="">All</OPTION>
            <%
                While Not rst.EOF
                    If CStr(rst("TypeID").Value) = Request("Type") Then
                        %><OPTION SELECTED VALUE="<%= rst("TypeID").Value %>"><%= rst("TypeName").Value %></OPTION><%
                    Else
                        %><OPTION VALUE="<%= rst("TypeID").Value %>"><%= rst("TypeName").Value %></OPTION><%
                    End If
                    rst.MoveNext
                Wend
            %>
        </select> 
        of size 
        <%
            Set rst = Nothing
            Set rst = db.Execute("SELECT DISTINCT [Size] FROM Clothing")
        %>
        <select size="1" name="Size">
            <OPTION VALUE="">Any</OPTION>
            <%
                While Not rst.EOF
                    If Request("Size") = rst("Size").Value Then
                        %><OPTION SELECTED VALUE="<%= rst("Size").Value %>"><%= rst("Size").Value %></OPTION><%
                    Else
                        %><OPTION VALUE="<%= rst("Size").Value %>"><%= rst("Size").Value %></OPTION><%
                    End If
                    rst.MoveNext
                Wend
            %>
        </select><input type="submit" value="Submit"></p>
        <table border="0" width="100%" bgcolor="#000000" cellspacing="1">
          <tr>
            <th nowrap bgcolor="#FFA724">Name</th>
            <th nowrap bgcolor="#FFA724">Size</th>
            <th nowrap bgcolor="#FFA724">Color</th>
            <th nowrap bgcolor="#FFA724">Type</th>
            <th nowrap bgcolor="#FFA724">StoreID</th>
          </tr>
        <%
          If Not rstItems.BOF Then rstItems.MoveFirst
          While Not rstItems.EOF
        %>
          <tr>
            <td bgcolor="#FFFFFF"><%= rstItems("Name") %></td>
            <td bgcolor="#FFFFFF"><%= rstItems("Size") %></td>
            <td bgcolor="#FFFFFF"><%= rstItems("Color") %></td>
            <td bgcolor="#FFFFFF"><%= rstItems("TypeName") %></td>
            <td bgcolor="#FFFFFF"><%= rstItems("StoreID") %></td>
          </tr>
        <%
            rstItems.MoveNext
          Wend
        %>
        </table>
      </form>
    </td>
  </tr>
</table>

<!-- No more code after this point -->

<p>This is an ASP (Active Server Pages) page. It uses a little database on the
server - in this sample it is the clothing.mdb in the same directory. For the
sake of the example we put in the database a few records and we used two tables: </p>

<blockquote>
  <p>Types - contains the clothing types with their names and an image for each
  type<br>
  Clothing - contains the actual items. The type field in this table links the
  items to their type. </p>

</blockquote>
<p>When we use the &quot;server side&quot; form above we can request all the
labels that match the filter specified in the form. The page will extract the
data from the database and show it. To pass the same data to the label the page
passes the parameters also to Step41data.asp which is referred by the OBJECT's
DATA attribute. This other ASP page sends the label statically and after that
extracts the data from the data base the same way the page does and adds it to
the label. </p>

<p>Compared to the other example which uses PARAM elements this technique is
more flexible. For instance in the ASP page that generates the label we can load
the label definition from a file or from the database (provided we have a label
repository implemented in the same or another database). The non-data part of
the label is static text commands so there is nothing difficult in obtaining it
from wherever we want. A note about the images on the label. If we want to make
such a page work with changeable labels we will need to design them so that each
image on them is referred correctly - especially if we have more than one page
like this. Perhaps the best way will be to refer the images on the label using
virtual paths - e.g. &quot;/labelimages/imagexxxx.jpg&quot; relative to the root
of the WEB site. We recommend this even if it looks unneeded at this point,
because if you extend the application in the future you may add many other pages
that work with labels and these pages can be in other directories. Therefore
using relative paths may lead to the need to correct the labels when you do
that.&nbsp; </p>
<p><b>When this is good and when it is not:</b>&nbsp; Loading the label design
and data using DATA attribute puts the label related work outside of the current
page. All the page needs to do is pass the appropriate parameters and of course
work with the ActiveX which is entirely a client side scripting. So, speaking
about the server side code this moves all the label and label data generation
code in separate server side script/page. That page in turn is much like a
typical ASP page (in our case we use ASP, but whatever technology you use the
script/module will be normal server side script/module). What makes it different
is that it serves not HTML but Active Label text commands, including cache data
entries. So, this looks very much like working with frames where one of the
frames is the ActiveX. The good and the bad sides of this approach are known to
WEB developers, the specifics in the case of the Active Label ActiveX are that this
allows the label to be changed without need to change the main HTML page and
even the page that generates the label - providing, of course, that it is
written in enough flexible manner. For example maximum flexibility can be
achieved if the page that generates the label is obtaining it from your
application's repository which should also contain a description of the data
used by the particular label so that the page can serve the label in a smart
way. </p>

<p>&nbsp; </p>

<p>&nbsp; </p>

</body>

</html>
