<%  
    ' We use this function to escape DB strings. The code required is
    ' shorter that way (compared to using the ADO's features in some places)
    Function dbEsc(str)
        dbEsc = Replace(str,"'","''")
    End Function

    Response.ContentType = "text/plain"
    Set db = Server.CreateObject("ADODB.Connection")
    db.Open "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & Server.MapPath("labels.mdb") & ";"
    
    Dim rlabel, rimage
    Dim labelID, imageID
    labelID = 0
    
    If Request.QueryString("LabelCaption") <> "" Then
        ' Before doing anything else - lets find the label ID if it exists
        Set rlabel = db.Execute("SELECT * FROM LABELS WHERE LabelName='" & _
                                dbEsc(Request.QueryString("LabelCaption")) & "'")
        If rlabel.EOF Then
            ' Label does not exist - create one. The label data will be saved later
            Set rlabel = Server.CreateObject("ADODB.Recordset")
            rlabel.Open "Labels", db, 1, 3, 2 ' Open the table to add new entry
            rlabel.AddNew
            rlabel("LabelName").Value = Request.QueryString("LabelCaption")
            ' The date is set automatically the first time
            rlabel.Update
        End If
        ' Obtain the labelID - we need it for any kind of operation
        labelID = rlabel("LabelID").Value
        rlabel.Close
    
        If Request.QueryString("ElementType").Count > 0 Then
            ' An element - we support only images in this example
            If Clng(Request.QueryString("ElementType")) = 5 Then
                Set rimage = Server.CreateObject("ADODB.Recordset")
                ' Try to find and existing image first
                rimage.Open "SELECT * FROM Images WHERE LabelID=" & labelID & " AND " & _
                            "ElementName='" & dbEsc(Request.QueryString("Name")) & "'", db, 1, 3, 1
                If rimage.EOF Then
                    ' The image does not exist - create it
                    rimage.Close
                    rimage.Open "Images", db, 1, 3, 2
                    rimage.AddNew
                    rimage("ElementName").Value = Request.QueryString("Name")
                    rimage("ImageType").Value = Request.QueryString("ImageType")
                    rimage("LabelID").Value = labelID
                End If
                ' Update the image data
                rimage("ImageData").Value = Request.BinaryRead(Request.TotalBytes)
                rimage.Update
                imageID = rimage("ImageID").Value
                rimage.Close
                
                ' Note: This is an example and its main aim is to be easy to install
                ' and test on whatever you have at hand - IIS, PWS, ALP
                ' In real world application you will have a bit different aim -
                ' application wide unified access to any label and its elements.
                ' Thus you will consider what path to return after the OK keyword
                ' and thus set the Src of the image in the label. This Src will be saved
                ' when the label data is saved and when the label is used afterwards
                ' it will be used to extract the image. So, you will probably prefer
                ' a virtual path e.g. /labelscripts/image.asp?ImageID=<theID>
                ' Anyway using relative path is more likely to cause excess development
                ' work in future application extensions than a virtual path.
                Response.Write "OK " & "image.asp?ImageID=" & imageID & vbCrLf
            Else
                Response.Write "ERR: This ASP page saves only images"
            End If
        Else
            ' The label itself
            Set rlabel = Server.CreateObject("ADODB.Recordset")
            rlabel.Open "SELECT * FROM Labels WHERE LabelID=" & labelID, db, 1, 3, 1
            rlabel("LabelData").Value = Request.BinaryRead(Request.TotalBytes)
            rlabel("DateModified").Value = Now
            rlabel.Update
            
            ' Unlike the images there is no need of returning URL or path when we save the label
            ' The Src property of the label is not saved. It makes no sense, because you
            ' load the label by composing a Src
            Response.Write "OK" & vbCrLf
        End If
    Else
        Response.Write "ERR: The label must have a name"
    End If
%>